// ===================================================================
//	fts_sqlite.h  SQLiteESvO ʊ֐Eݒ
//					                          K.Nakamura  2023/09/03
//		PjFTS_LIKE   SiLIKEŁj
//			@\̒`@ASQLite@`
//			B֐iI[vE쐬Fopen A\̂ɃZbgFsetj
// =================================================================== 

// ---------------- f[^\̒`@------------------------------ 
											// FTS_FILE f[^
typedef struct 
{
	char *index_key;				//	1 CfbNX		TEXT PK
	char *fts_data;					//	2 Spf[^	TEXT

} FTS_LIKE_REC;

// FTS_LIKE_REC fts_like_rec;



// ------------ SQLite S@f[^x[X`@fts_like@p@--------

char *FTS_LIKE_tname  = "FTS_LIKE";
char *FTS_LIKE_table  = "index_key TEXT PRIMARY KEY , fts_data TEXT";

char FTS_LIKE_fname[500]  = "fts_like.db";
char FTS_LIKE_ORG_fname[500]  = "input.txt";

sqlite3 *fts_like_db;
sqlite3_stmt *fts_like_stmt_get ;
sqlite3_stmt *fts_like_stmt_insert ;

char *fts_like_sql_insert = "INSERT INTO FTS_LIKE values( ?1 , ?2  )";
// char *fts_like_sql_get = "SELECT * FROM FTS_LIKE WHERE fts_data like '%?1%'";

// ------------ SQLite S@
								// 
char sql_statement[2000];
char *error_message;

	
// =========================================================================
//   Name     : int fts_like_open(void)
//   Usage    : p`p̃f[^x[XI[vAȂ΍쐬i{e[u쐬jB
//   Parameter: Ȃ
//   Return   : 0 :OK
// ========================================================================
int fts_like_open(void)
{
	int rc;
			// f[^x[Xt@CVK or I[v@

	rc = sqlite3_open_v2( FTS_LIKE_fname, &fts_like_db , SQLITE_OPEN_READWRITE , NULL);
	if(rc == SQLITE_OK ) fprintf(stdout, "Open:[%s]\n", FTS_LIKE_fname );
	else{
		rc = sqlite3_open_v2( FTS_LIKE_fname , &fts_like_db , SQLITE_OPEN_READWRITE | SQLITE_OPEN_CREATE , NULL);
		if(rc == SQLITE_OK){
			fprintf(stdout, "Create:[%s]\n", FTS_LIKE_fname );

			sprintf(sql_statement, "create table %s(%s)", FTS_LIKE_tname , FTS_LIKE_table);
			rc = sqlite3_exec( fts_like_db , sql_statement, NULL, NULL, &error_message);
			if(rc == SQLITE_OK)	fprintf(stdout, "Table[%s] \n", FTS_LIKE_tname);
			else{
				fprintf(stdout, "Table NG[%s] \n", error_message);
				return -1;
			}
		}
		else{
			fprintf(stdout, "Ceate Error[%s][%s]\n",  FTS_LIKE_fname , sqlite3_errmsg( fts_like_db ));
			return -1;
		}
	}
	return 0;
}


// =========================================================================
//   Name     : int fts_like_set( FTS_LIKE_REC  * )
//   Usage    : FTS_FILEDB̓e\̂ɃZbgB
//   Parameter: Ȃ
//   Return   : Ȃ
// ========================================================================
void fts_like_set( FTS_LIKE_REC *fl )
{
	int i;	

	char temp_s1[5000];
	char temp_s2[15000];

	char temp_u1[15000];
	char temp_u2[45000];

	i=0;
	while(1){
		if(strcmp(sqlite3_column_name(fts_like_stmt_get, i),"index_key")==0){
			strcpy(temp_u1 ,  (char*) sqlite3_column_text(fts_like_stmt_get, i));
		}
		else if(strcmp(sqlite3_column_name(fts_like_stmt_get , i),"fts_data")==0){
			strcpy(temp_u2 ,  (char*) sqlite3_column_text(fts_like_stmt_get, i));
			break;
		}
		i++;
	}

	SetNkfOption("-Wsx");

	NkfConvert(temp_s1, temp_u1);
	NkfConvert(temp_s2, temp_u2);

	fl->index_key = temp_s1; 
	fl->fts_data  = temp_s2;

	return;
}
